#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "__fc_builtin.h" 
#define TRUE 1
#define FALSE 0
 
typedef int bool;
typedef enum { ENCRYPT, DECRYPT } cmode;
 
const char *l_alphabet = "HXUCZVAMDSLKPEFJRIGTWOBNYQ";
const char *r_alphabet = "PTLNBQDEOYSFAVZKGJRIHWXUMC";
 
void chao(const char *in, char *out, cmode mode, bool show_steps) {
    int i, j, index;
    char store;
    size_t len = strlen(in);
    char left[27], right[27], temp[27];
    strcpy(left, l_alphabet);
    strcpy(right, r_alphabet);
    temp[26] = '\0';
    /*@ loop unroll len; */
    for (i = 0; i < len; ++i ) {
        if (show_steps) printf("%s  %s\n", left, right);
        if (mode == ENCRYPT) {
          char* res = strchr(right, in[i]);
          if (res == NULL) { out[i] = in[i]; continue; }
          else {
            index = res - right;
            out[i] = left[index];
          }
        } else {
          char *res = strchr(left, in[i]);
          if (res == NULL) {
            out[i] = in[i];
            continue;
          }            
          else {
            index =  res - left;
            out[i] = right[index];
          }
        }
        if (i == len - 1) break;
 
        /* permute left */
        /*@ split index; */
        for (j = index; j < 26; ++j) temp[j - index] = left[j];
        for (j = 0; j < index; ++j)
          temp[26 - index + j] = left[j];
        /*@ merge index; */
        store = temp[1];
        for (j = 2; j < 14; ++j) temp[j - 1] = temp[j];
        temp[13] = store;
        strcpy(left, temp);
 
        /* permute right */
        /*@ split index; */
        for (j = index; j < 26; ++j) temp[j - index] = right[j];
        for (j = 0; j < index; ++j) temp[26 - index + j] = right[j];
        store = temp[0];
        for (j = 1; j < 26; ++j) temp[j - 1] = temp[j];
        temp[25] = store;
        store = temp[2];
        for (j = 3; j < 14; ++j) temp[j - 1] = temp[j];
        temp[13] = store;
        strcpy(right, temp);
        /*@ merge index; */
        ;
    }
    out[len] = 0;
}

char *strcpy(char *dest, const char *src) {
  memcpy(dest, src, strlen(src)+1);
  return dest;
}

int strcmp(const char *s1, const char *s2) {
  while (*s1 && *s2 && *s1 == *s2) {
    s1++;
    s2++;
  }
  if (*s1 < *s2)
    return -1;
  if (*s1 > *s2)
    return 1;
  return 0;
}

#define LEN 10

int main() {
  char plain_text[LEN];
  /*@ loop unroll LEN; */
  for (int i = 0; i < LEN - 1; i++)
    plain_text[i] = 'A' + Frama_C_interval(0, 25);
  plain_text[LEN-1]=0;
  char *cipher_text = malloc(strlen(plain_text) + 1);
  char *plain_text2 = malloc(strlen(plain_text) + 1);
  if (cipher_text == NULL || plain_text2 == NULL) return 1;
  printf("The original plaintext is : %s\n", plain_text);
  printf("\nThe left and right alphabets after each permutation"
         " during encryption are :\n\n");
  chao(plain_text, cipher_text, ENCRYPT, TRUE);
  printf("\nThe ciphertext is : %s\n", cipher_text);
  chao(cipher_text, plain_text2, DECRYPT, FALSE);
  printf("\nThe recovered plaintext is : %s\n", plain_text2);
  int res = strcmp(plain_text, plain_text2);
  free(cipher_text);
  free(plain_text2);
  return res;
}
